package rule

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/md"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	"errors"
	"github.com/jinzhu/copier"
	"time"
	"xorm.io/xorm"
)

func AddOrder(eg *xorm.Engine, req map[string]string) {
	one, _ := db.SysCfgGetOne(eg, "capital_pool_mul")
	minMOneyData, _ := db.SysCfgGetOne(eg, "capital_pool_min_money")
	var capitalPoolMul float64 = 0
	var minMOney float64 = 498
	if one != nil {
		capitalPoolMul = zhios_order_relate_utils.StrToFloat64(one.Val)
	}
	if minMOneyData != nil {
		minMOney = zhios_order_relate_utils.StrToFloat64(minMOneyData.Val)
	}
	price := zhios_order_relate_utils.StrToFloat64(req["price"])
	req["price"] = zhios_order_relate_utils.Float64ToStrByPrec(zhios_order_relate_utils.StrToFloat64(req["price"])*capitalPoolMul, 2)
	if req["type"] == "mall_goods_user_lv" {
		for i := 0; i < zhios_order_relate_utils.StrToInt(req["num"]); i++ {
			var data = &model.MallOrdCapitalPoolTotal{
				Uid:        zhios_order_relate_utils.StrToInt(req["uid"]),
				Price:      req["price"],
				LeavePrice: req["price"],
				Num:        1,
				UpdateTime: time.Now(),
				Oid:        req["oid"],
				Type:       1,
			}
			eg.Insert(data)
		}
	} else {
		max := db.GetMaxPrice(eg, req["uid"])
		if max != nil {
			//判断之前剩下多少
			var leave float64 = 0
			onemoney := minMOney * capitalPoolMul
			if zhios_order_relate_utils.StrToFloat64(max.OtherPrice) > 0 {
				num := int(zhios_order_relate_utils.StrToFloat64(max.OtherPrice) / onemoney)
				leave = zhios_order_relate_utils.StrToFloat64(max.OtherPrice) - onemoney*float64(num)
			}
			nowMoney := leave + price*capitalPoolMul
			nowNum := int(nowMoney / onemoney)
			max.Num += nowNum
			max.LeavePrice = zhios_order_relate_utils.Float64ToStrByPrec(zhios_order_relate_utils.StrToFloat64(max.LeavePrice)+zhios_order_relate_utils.StrToFloat64(req["price"]), 3)
			max.OtherPrice = zhios_order_relate_utils.Float64ToStrByPrec(zhios_order_relate_utils.StrToFloat64(max.OtherPrice)+zhios_order_relate_utils.StrToFloat64(req["price"]), 3)
			max.UpdateTime = time.Now()
			eg.Where("id=?", max.Id).AllCols().Update(max)
		}
	}
	return
}

func Pool(eg *xorm.Engine, price string) error {
	if zhios_order_relate_utils.StrToFloat64(price) == 0 {
		return errors.New("没有可分配金额")
	}
	ones, _ := db.SysCfgGetOne(eg, "capital_pool_mul")
	minMOneyData, _ := db.SysCfgGetOne(eg, "capital_pool_min_money")
	var capitalPoolMul float64 = 0
	var minMOney float64 = 498
	if ones != nil {
		capitalPoolMul = zhios_order_relate_utils.StrToFloat64(ones.Val)
	}
	if minMOneyData != nil {
		minMOney = zhios_order_relate_utils.StrToFloat64(minMOneyData.Val)
	}
	session := eg.NewSession()
	defer session.Close()
	err := session.Begin()
	if err != nil {
		session.Rollback()
		return err
	}
	pool, err := db.GetNewCapitalPoolSess(session)
	if err != nil || pool.Id == 0 {
		session.Rollback()
		return errors.New("没有记录")
	}
	if pool.IsUse == 0 {
		session.Rollback()

		return errors.New("没有开启")
	}
	poolBonus := db.GetBonusValueAndCoin(session, &pool, price)
	if poolBonus == nil {
		session.Rollback()

		return errors.New("没有可分配金额")
	}
	//生成分红记录初始数据
	var bonus model.NewCapitalPoolBonus
	bonus.BonusType = 2
	bonus.CreateAt = time.Now()
	bonus.BonusValue = price
	if poolBonus.BonusValue-poolBonus.OldBonusValue > 0 {
		bonus.OutBonusValue = zhios_order_relate_utils.AnyToString(poolBonus.BonusValue - poolBonus.OldBonusValue)
	}
	one, err := session.InsertOne(&bonus)
	if err != nil || one == 0 {
		session.Rollback()
		return errors.New("失败")
	}
	//统计数量
	//礼包的
	sql := `SELECT SUM(num) as sum,uid FROM mall_ord_capital_pool_total WHERE leave_price>0 and num>0  GROUP BY uid;`
	nativeString, err := db.QueryNativeStringSess(session, sql)
	if err != nil {
		session.Rollback()

		return err
	}
	sqlFirst := `SELECT uid FROM mall_ord_capital_pool_total WHERE 1=1 and (type=1 or other_price>=?) GROUP BY uid;`
	nativeStringFirst, errFirst := db.QueryNativeStringSess(session, sqlFirst, capitalPoolMul*minMOney)
	if errFirst != nil {
		session.Rollback()

		return err
	}
	sum := 0
	ids := make([]string, 0)
	newIds := make([]string, 0)
	//有的分的算份数
	for _, v := range nativeString {
		sum += zhios_order_relate_utils.StrToInt(v["sum"])
		ids = append(ids, v["uid"])
	}
	//没得分的 站位
	for _, v := range nativeStringFirst {
		if zhios_order_relate_utils.InArr(v["uid"], ids) == false || len(ids) == 0 {
			sum += 1
			newIds = append(newIds, v["uid"])
		}
	}
	if sum == 0 {
		session.Rollback()
		return errors.New("没有分配份数")
	}
	oneMoney := zhios_order_relate_utils.StrToFloat64(price) / float64(sum)
	//金额小的先扣 扣不完 给下一个
	var userMap = make(map[string]float64)
	var userSumMap = make(map[string]float64)
	for _, v := range ids {
		//读取用户的记录
		var leave float64 = 0
		var data []model.MallOrdCapitalPoolTotal
		err := session.Where("uid=? and leave_price>? and num>?", v, 0, 0).Find(&data)
		if err != nil {
			session.Rollback()
			return err
		}
		for _, v1 := range data {
			onemoneydata := oneMoney * float64(v1.Num)
			userSumMap[v] += onemoneydata
			leave, err = OneDoing(session, v1, onemoneydata, leave, minMOney*capitalPoolMul)
			if err != nil {
				session.Rollback()
				return err
			}
		}
		//剩下的都进损失了
		if leave > 0 {
			//剩下的进损失
			err = db.InsertCapitalPoolLossMoney(session, v, zhios_order_relate_utils.Float64ToStrByPrec(leave, 3), "分红损失", "0", "capital_pool")
			if err != nil {
				session.Rollback()
				return err
			}
			userSumMap[v] -= leave
			leave = 0
		}
		userMap[v] = leave
	}
	for _, v := range nativeStringFirst {
		var leave = oneMoney
		if zhios_order_relate_utils.InArr(v["uid"], ids) == false || len(ids) == 0 { //这些都是没的分的就进损失
			//剩下的进损失
			err = db.InsertCapitalPoolLossMoney(session, v["uid"], zhios_order_relate_utils.Float64ToStrByPrec(leave, 3), "分红损失", "0", "capital_pool")
			if err != nil {
				session.Rollback()
				return err
			}
		}
	}
	var RealBonusValue float64 = 0
	for k, v := range userSumMap {
		if v <= 0 {
			continue
		}
		bools := Finflow(session, k, v)
		if bools == false {
			session.Rollback()
			return errors.New("失败")
		}
		RealBonusValue += v
	}
	bonus.RealBonusValue = zhios_order_relate_utils.Float64ToStrByPrec(RealBonusValue, 2)
	bonus.LossBonusValue = zhios_order_relate_utils.Float64ToStrByPrec(zhios_order_relate_utils.StrToFloat64(price)-RealBonusValue, 2)
	bonus.BonusUserNum = zhios_order_relate_utils.IntToStr(sum)
	bonus.BonusUserRecord = zhios_order_relate_utils.SerializeStr(userSumMap)
	bonus.BonusPeriod = bonus.Id
	update, err := session.ID(bonus.Id).Update(&bonus)
	if err != nil || update == 0 {
		session.Rollback()
		return errors.New("失败")
	}
	session.Commit()
	return nil
}
func OneDoing(sess *xorm.Session, data model.MallOrdCapitalPoolTotal, oneMoney, leave, minMoney float64) (float64, error) {
	money := oneMoney + leave
	if zhios_order_relate_utils.StrToFloat64(data.LeavePrice) <= 0 {
		return money, nil
	}
	if zhios_order_relate_utils.StrToFloat64(data.LeavePrice)-money < 0 {
		leave = money - zhios_order_relate_utils.StrToFloat64(data.LeavePrice)
		data.LeavePrice = "0"
	} else {
		leave = 0
		data.LeavePrice = zhios_order_relate_utils.Float64ToStrByPrec(zhios_order_relate_utils.StrToFloat64(data.LeavePrice)-money, 2)
	}
	//剩余有钱 并且是普通商品的 还有普通商品的金额大于最小分配金额
	if zhios_order_relate_utils.StrToFloat64(data.LeavePrice) > 0 && data.Type == 0 && zhios_order_relate_utils.StrToFloat64(data.OtherPrice) >= minMoney {
		data.Num = int(zhios_order_relate_utils.StrToFloat64(data.LeavePrice) / minMoney)
		if data.Num == 0 {
			data.Num = 1
		}
	}
	update, err := sess.Where("id=?", data.Id).Cols("num,leave_price").Update(&data)
	if update == 0 || err != nil {
		return leave, errors.New("失败")
	}
	return leave, nil
}

func AddBonusOrd(engine *xorm.Engine, t *md.BonusOrdParam) error {

	//获取分红基础设置
	pool, err := db.GetNewCapitalPool(engine)
	if err != nil || pool.Id == 0 {
		return errors.New("分红设置有误")
	}
	if pool.IsUse == 0 {
		return errors.New("功能没有开始使用，插入分红失败")
	}
	var capitalPoolOrd model.NewCapitalPoolOrd
	copier.Copy(&capitalPoolOrd, &t)
	capitalPoolOrd.Uid = zhios_order_relate_utils.StrToInt(t.Uid)
	capitalPoolOrd.OrdId = zhios_order_relate_utils.AnyToInt64(t.OrdId)
	capitalPoolOrd.CreateAt = time.Now()
	capitalPoolOrd.UpdateAt = time.Now()
	capitalPoolOrd.SettleCardinality = pool.SettleCardinality
	if pool.SettleCardinality == "price" { //价格为基数
		capitalPoolOrd.DepositValue = t.PriceValue
		capitalPoolOrd.Commission = t.PriceValue
	}
	one, err := engine.InsertOne(&capitalPoolOrd)
	if err != nil || one == 0 {
		if err == nil {
			err = errors.New("插入数据有误！")
		}
		return err
	}
	return nil
}

func Finflow(session *xorm.Session, uid string, amount float64) bool {
	beforeAmount := "0"
	afterAmount := "0"
	var affected int64 = 0
	userProfile, err := db.UserProfileFindByIDWithSession(session, uid)

	if err != nil || userProfile == nil {
		return false
	}
	now := time.Now()
	ItemTitle := "消费补贴"
	finUserFlow := model.FinUserFlow{
		Type:         0,
		Uid:          zhios_order_relate_utils.StrToInt(uid),
		Amount:       zhios_order_relate_utils.Float64ToStrByPrec(amount, 9),
		BeforeAmount: beforeAmount,
		AfterAmount:  afterAmount,
		OrdType:      "self_buy_capital_pool",
		OrdId:        "",
		OrdAction:    104,
		OrdDetail:    "",
		State:        2,
		OrdTitle:     ItemTitle,
		CreateAt:     now,
		UpdateAt:     now,
	}

	// 更新用户余额
	finUserFlow.BeforeAmount = userProfile.FinValid
	userProfile.FinValid = zhios_order_relate_utils.Float64ToStrByPrec(zhios_order_relate_utils.AnyToFloat64(userProfile.FinValid)+zhios_order_relate_utils.AnyToFloat64(amount), 9)
	userProfile.FinTotal = userProfile.FinTotal + zhios_order_relate_utils.StrToFloat32(zhios_order_relate_utils.Float64ToStrByPrec(amount, 9))
	affected, err = db.UserProfileUpdateWithSession(session, uid, userProfile, "fin_total", "fin_valid")
	finUserFlow.AfterAmount = userProfile.FinValid
	has, errs := db.InsertCommWithSession(
		session, &finUserFlow)
	if affected == 0 || err != nil || errs != nil || has == 0 {
		return false
	}
	return true
}
